/*
 * Aspera, Inc.
 *
 * C++ only.
 *
 * Contains default values and constants. See also fasp_stream_constants.h.
 */
#ifndef ASPERA_CONSTANTS_H
#define ASPERA_CONSTANTS_H

#include <string>
#include <fasp_stream_constants.h>


class Constants
{
public:

    const static int UNINITIALIZED_POLICY_TYPE = 0;

    const static int UNINITIALIZED_CIPHER_TYPE = 0;

    const static char *policyTypes[];
    const static char *cipherTypes[];


    const static int TWO_Mb = 2048000;

    /**
     * Default UDP port number is 33001 (for both send and receive)
     */
    const static int UNINITIALIZED_PORT_NUMBER = 33001;
    /**
     * Default datagram size is 1024
     */
    const static int UNINITIALIZED_DATAGRAM_SIZE = 1024;
    /**
     * Default chunk size is 16777216 (16 Mb)
     */
    const static int UNINITIALIZED_CHUNK_SIZE = 16777216;
    /**
     * Default target rate is 10000 kbps (10 Mbps)
     */
    const static int UNINITIALIZED_RATE_TARGET = 10000;  // kbps, 10Mbps experimentally found
    /**
     * Default minimum rate is 100 kbps
     */
    const static int UNINITIALIZED_RATE_MINIMUM = 100;   //  TODO:  NO IDEA WHAT DEFAULT MIN IS
    /**
     * Default aggressiveness is zero
     */
    const static int UNINITIALIZED_AGGRESSIVENESS = 0;   //  TODO:  NO IDEA WHAT DEFAULT AGGRESSIVENESS IS
    /**
     * Minimum datagram size is 296 (setting datagram size smaller will cause an error)
     */
    const static int MINIMUM_DATAGRAM_SIZE = 296;
    /**
     * Maximum datagram size is 65535 (setting datagram size larger will cause an error)
     */
    const static int MAXIMUM_DATAGRAM_SIZE = 65535;
    /**
     * Max Memory
     */
    const static int UNINITIALIZED_MAX_MEMORY = 2048000000;
    /**
     * Default Debug Level
     */
    const static int UNINITIALIZED_DEBUG_LEVEL = 0;
    /**
     * Default Log Directory
     */
    const static char* UNINITIALIZED_LOG_DIRECTORY;
    /**
     * UDP Port
     */
    const static int UNINITIALIZED_UDP_PORT = 33001;
    /**
     * Force send 0=off or milliseconds
     */
    const static int UNINITIALIZED_FORCE_SEND = 0;
    /**
     *
     */
    const static char* UNINITIALIZED_PRIVATE_KEY_FILE;
    /**
     *
     */
    const static char* UNINITIALIZED_SSH_USER;
    /**
     *
     */
    const static char* UNINITIALIZED_COMMAND_TO_EXECUTE;
};

#endif
