#pragma once

#include <string>
#include <cstddef>

#include "FaspInputStream.h"
#include "FaspOutputStream.h"

class FaspStream
{
private:
    FaspInputStream in;
    FaspOutputStream out;

public:
    FASPSTREAM_CPP_API void setFaspstreamPath(const std::string& faspstreamPath);
    FASPSTREAM_CPP_API std::string getFaspstreamPath() const;
    FASPSTREAM_CPP_API void close();
    FASPSTREAM_CPP_API void forceClose();

    FASPSTREAM_CPP_API std::string getInputXferResult() const;
    FASPSTREAM_CPP_API bool startInputReceiver();
    FASPSTREAM_CPP_API int getInputPort() const;
    FASPSTREAM_CPP_API void setInputPort(int tcpPort);
    FASPSTREAM_CPP_API int getInputMaxMemory() const;
    FASPSTREAM_CPP_API void setInputMaxMemory(int maxMem);
    FASPSTREAM_CPP_API int getInputDebugLevel() const;
    FASPSTREAM_CPP_API void setInputDebugLevel(int level);
    FASPSTREAM_CPP_API std::string getInputLogDirectory() const;
    FASPSTREAM_CPP_API void setInputLogDirectory(const std::string& logDir);
    FASPSTREAM_CPP_API int read(char* buffer, int offset, int length);
    FASPSTREAM_CPP_API void closeInput();
    FASPSTREAM_CPP_API void forceCloseInput();


    FASPSTREAM_CPP_API bool connectOutput(const std::string& host);
    FASPSTREAM_CPP_API int getOutputMaxMemory() const;
    FASPSTREAM_CPP_API void setOutputMaxMemory(int maxMem);
    FASPSTREAM_CPP_API int getOutputDebugLevel() const;
    FASPSTREAM_CPP_API void setOutputDebugLevel(int level);
    FASPSTREAM_CPP_API std::string getOutputLogDirectory() const;
    FASPSTREAM_CPP_API void setOutputLogDirectory(const std::string& logDir);
    FASPSTREAM_CPP_API int getOutputUdpPort() const;
    FASPSTREAM_CPP_API void setOutputUdpPort(int port);
    FASPSTREAM_CPP_API int getOutputPort() const;
    FASPSTREAM_CPP_API void setOutputPort(int tcpPort);
    FASPSTREAM_CPP_API int getOutputDatagramSize() const;
    FASPSTREAM_CPP_API void setOutputDatagramSize(int size);
    FASPSTREAM_CPP_API int getOutputChunkSize() const;
    FASPSTREAM_CPP_API void setOutputChunkSize(int size);
    FASPSTREAM_CPP_API std::string getOutputHostname() const;
    FASPSTREAM_CPP_API void setOutputHostname(const std::string& name);
    FASPSTREAM_CPP_API int getOutputRateTarget() const;
    FASPSTREAM_CPP_API void setOutputRateTarget(int target);
    FASPSTREAM_CPP_API Constants::CIPHER_TYPE getOutputCipherType() const;
    FASPSTREAM_CPP_API void setOutputCipherType(Constants::CIPHER_TYPE type);
    FASPSTREAM_CPP_API bool isOutputLockTarget() const;
    FASPSTREAM_CPP_API void setOutputLockTarget(bool target);
    FASPSTREAM_CPP_API int getOutputRateMinimum() const;
    FASPSTREAM_CPP_API void setOutputRateMinimum(int minimum);
    FASPSTREAM_CPP_API bool isOutputLockMinimum() const;
    FASPSTREAM_CPP_API void setOutputLockMinimum(bool lockMin);
    FASPSTREAM_CPP_API Constants::POLICY_TYPE getOutputPolicy() const;
    FASPSTREAM_CPP_API void setOutputPolicy(Constants::POLICY_TYPE newPolicy);
    FASPSTREAM_CPP_API bool isOutputLockPolicy() const;
    FASPSTREAM_CPP_API void setOutputLockPolicy(bool lock);
    FASPSTREAM_CPP_API int getOutputAggressiveness() const;
    FASPSTREAM_CPP_API void setOutputAggressiveness(int aggressive);
    FASPSTREAM_CPP_API void write(const char* buffer, int length);
    FASPSTREAM_CPP_API std::string getOutputXferResult() const;
    FASPSTREAM_CPP_API void closeOutput();
    FASPSTREAM_CPP_API void forceCloseOutput();
    FASPSTREAM_CPP_API int eof();
};
